﻿--  _  __                   _ _          ___   --
-- | |/ /                  (_|_)        |__ \  --
-- | ' / __ ___      ____ _ _ __    _   __ ) | --
-- |  < / _` \ \ /\ / / _` | | \     \ / // /  --
-- | . \ (_| |\ V  V / (_| | | |    \ V // /_  --
-- |_|\_\__,_| \_/\_/ \__,_|_|_|     \_/|____| --
--                              ______         --
--                             |______|        --

--============================================================--Toggles--============================================================--

mysounds = true --====only use on local files, not youtube=====--
lewd = false --====Set to true to use Lewd pics in the lewd folder=====--
lewdCount = 1 --====Set to the number of Lewd pics you put in the lewd folder=====--
kawaiiCount = 69 --====Set to the number of normal pics you put in the kawaii folder=====--

--============================================================--Toggles--============================================================--

--============================================================--Initial Functions--============================================================--

jumping = PlayerCanJump()
quality = GetQualityLevel()

function fif(test, if_true, if_false)
  if test then return if_true else return if_false end
end

hifi = GetQualityLevel() > 2
function ifhifi(if_true, if_false)
  if hifi then return if_true else return if_false end
end

quality = GetQualityLevel4()
function ByQuality4(low,med,high,ultra)
	if quality < 2 then return low
	elseif quality <3 then return med
	elseif quality <4 then return high
	else return ultra end
end

skinvars   = GetSkinProperties()
trackWidth = skinvars["trackwidth"]
ispuzzle   = skinvars.colorcount>1
casual     = trackWidth==8

local laneDividers  = skinvars["lanedividers"]
local shoulderLines = skinvars["shoulderlines"]

--============================================================--Initial Functions--============================================================--

--==============================================================--Scene Setters--==============================================================--
SetScene{
	glowpasses             = 0,
	glowspread             = 100,
	water                  = jumping,
	minwaterrandomdarkness = 10,
	watertint              = {r=11,g=11,b=11,a=11},
	watertexture           = "waterBW.png",
	watertype              = 2,
	numvisiblewaterchunks  = 8,
	towropes               = jumping,
	useblackgrid           = false,

  airdebris_count = 700,
	airdebris_density = 5,
	airdebris_layer = 10,
	airdebris_texture      = "star.png",

	use_intro_swoop_cam                = true,
	hide_default_background_verticals  = true,
	twistmode = {curvescaler=1, steepscaler=.1},
}

--==============================================================--Scene Setters--==============================================================--

--=================================================================--Colours--=================================================================--

--[[colour_palettes = {
	{{214,0,254},{0,176,255},{0,184,0},{255,255,0},{255,0,0}}, --default [1]
	{{252,197,192}, {250,159,181}, {247,104,161}, {197,27,138}, {122,1,119}}, --cool, pink-purple [2]
	{{212,185,218},{201,148,199},{223,101,176},{221,28,119},{152,0,67}}, --pink-red [3]
	{{254,217,118},{254,178,76},{253,141,60},{240,59,32},{189,0,38}}, -- Sunset(yellow-red) [4]
	{{176,0,255},{111,0,255},{0,133,255},{0,197,255},{0,255,249}}, --Riptide vertigo (purple-cyan) [5]
	{{179,72,255},{145,111,242},{111,151,229},{78,192,219},{44,231,204}}, --whispers in the dark (lilac-cyan) [6]
	{{7,155,133},{11,166,10},{33,245,182},{228,135,48},{174,1,57}}, --gitingas (teal-maroon) [7]
	{{156,57,213},{0,156,213},{156,213,0},{213,146,0},{252,0,53}}, --Huna soft (rainbow-ish) [8]
}

colours_index = math.random(1,#colour_palettes)

track_colours=colour_palettes[colours_index]

SetTrackColors(track_colours)]]--


SetTrackColors { --enter any number of colors here. The track will use the first ones on less intense sections and interpolate all the way to the last one on the most intense sections of the track
    {r=214, g=0, b=254},
    {r=0, g=176, b=255},
    {r=0, g=184, b=0},
    {r=255, g=255, b=0},
    {r=255, g=0, b=0}
}

if skinvars.colorcount < 5 then
	SetBlockColors {
    {r=0, g=176, b=255},
    {r=0, g=184, b=0},
    {r=255, g=255, b=0},
    {r=255, g=0, b=0}
	}
else
	SetBlockColors {
    {r=214, g=0, b=254},
    {r=0, g=176, b=255},
    {r=0, g=184, b=0},
    {r=255, g=255, b=0},
    {r=255, g=0, b=0}
	}
end

--=================================================================--Colours--=================================================================--

--=================================================================--Lights--=================================================================--
if ispuzzle then
	CreateLight {
		type       = "directional",
		railoffset = -1,
		range      = 10,
		intensity  = 1,
		color      = {255,255,255},
		transform  = {
			position = {0,2,0},
			rotation = {.4,346.2,0},
		},
	}
end

--=================================================================--Lights--=================================================================--

--==================================================================--Sounds--=================================================================--

--Cool custom sounds that don't work for youtube songs
LoadSounds{
	hit             = fif(mysounds,"hit.wav"),
	hitgrey         = fif(mysounds,"hitgrey.wav"),
	trickfail       = fif(mysounds,"hitgrey.wav"),
	matchsmall      = "Silent.wav",
	matchmedium     = "Silent.wav",
	matchlarge      = "Silent.wav",
	matchhuge       = "Silent.wav",
	overfillwarning = "overfillwarning.wav",
}

--[[Default sounds that work with everything
LoadSounds{
	trickfail       = "Silent.wav",
	matchsmall      = "Silent.wav",
	matchmedium     = "Silent.wav",
	matchlarge      = "Silent.wav",
	matchhuge       = "Silent.wav",
	overfillwarning = "Silent.wav"
}]]--
--==================================================================--Sounds--=================================================================--

--=============================================================--Block Appearance--============================================================--

if not jumping then
	SetBlocks {
		maxvisiblecount = fif(hifi,100,50),
		colorblocks     = {
			mesh           = "Lozenge.obj",
			shader         = "VertexColorUnlitTinted",
			texture        = "Lozenge.png",
		    height         = 0,
		    float_on_water = false,
			reflect        = true,
		    scale          = {1,1,1},
		},
		greyblocks      = {
			mesh           = "spike.obj",
			shader         = "Rim Light",
			shadersettings = {_Brightness=1},
			texture        = "spike.png",
			reflect        = true,
			height         = 0,
			colorMode      = "highway",
--[[			shadercolors   = {
					_Color    = {
						colorsource = "highway",
						scaletype   = "intensity",
						minscaler   = 0.1,
						maxscaler   = 0.4,
					},
			},]]--
		},
		powerups={
			powerpellet = {
				mesh         = "PowerHeart.obj",
				shader       = "VertexColorUnlitTinted", shadersettings={_Brightness=2},
				texture      = "White.png",
				shadercolors = {
					_Color      = "highwayinverted",
					_Scale      = "Intensity"},
				reflect      = true,
				height = 0.10,
			},
			whiteblock={
				mesh    = "Lozenge.obj",
				shader  = "UnlitTintedTex",
				reflect = true,
				texture = "White.png",
			}
		}
	}
else
	SetBlocks {
		colorblocks = {
			shader     = "VertexColorUnlitTinted",
		}
	}
end

SetBlockFlashes{
	texture = "black.png"
}

SetPuzzleGraphics{
	usesublayerclone    = false,
	puzzlematchmaterial = {
		shader             = "Unlit/Transparent",
		texture            = "tileMatchingBars2.png",
		aniso              = 9,
	},
	puzzleflyupmaterial = {
		shader             = "VertexColorUnlitTintedAdd",
		texture            = "tileMatchingBars2.png",
		},
  	puzzlematerial      = {
		shader             = "VertexColorUnlitTintedAdd",
		texture            = "tilesSquare.png",
		texturewrap        = "clamp",
		aniso              = 9,
		usemipmaps         = "false",
		shadercolors       = {
			_Color            = {255,255,255,255},
		}
	}
}

--=============================================================--Block Appearance--============================================================--

--============================================================--Player Appearance--============================================================--


if jumping then
	SetPlayer{
		cameramode = "first_jumpthird",


		camfirst={ --Sets the camera position when in first person mode.
			pos={0,2.7,-3.5},
			rot={20.5,0,0},
			strafefactor = 1
		},
		camthird={ --Sets the two camera positions for 3rd person mode. Lerps out towards pos2 when the song is less intense.
      pos={0,2.7,-3.5},
      rot={20.5,0,0},
      strafefactor = 0.75,
      strafefactorFar = 1},
      surfer = {
  			arms = {
  				shader       = "RimLightHatchedSurfer",
  				shadercolors = {
  					_Color      = {
  						colorsource = "highway",
  						scaletype   = "intensity",
  						minscaler   = 3,
  						maxscaler   = 6,
  						param       = "_Threshold",
  						paramMin    = 2,
  						paramMax    = 2
  					},
  					_RimColor   ={0,0,0}
  				},
  				texture      = "FullLeftArm_1024_wAO.png",
  			},
        board = {
  				shader       = ifhifi("RimLightHatchedSurferExternal","VertexColorUnlitTinted"),
  				renderqueue  = 3999,
  				shadercolors = {
  					_Color      = {
  						colorsource = "highway",
  						scaletype   = "intensity",
  						minscaler   = 5,
  						maxscaler   = 5,
  					},
  					_RimColor   = {0,0,0},
  				},
  				shadersettings = {
  					_Threshold    = 11,
  				},
  				texture        = "board_internalOutline.png",
  			},
        body = {
  				shader       = "RimLightHatchedSurferExternal",
  				renderqueue  = 3000,
  				shadercolors = {
  					_Color      = {
  						colorsource = "highway",
  						scaletype   = "intensity",
  						minscaler   = 3,
  						maxscaler   = 3,
  					},
  					_RimColor   = {0,0,0},
  				},
  				shadersettings = {
  					_Threshold    = 1.7,
  				},
  				texture        = "robot_HighContrast.png"
  			}
		}
	}
else
SetPlayer{
  cameramode = "third",
  camthird   = {
        pos = {0,2.85,-1.5},
        rot = {19,1,0},
    strafefactorFar = .9,
         pos2 = {0,14.375,-11.5},
         rot2 = {30,0,0},
    strafefactorFar = .9,
    transitionspeed = 1.5,
    puzzleoffset    = -0.65,
    puzzleoffset2   = -1.5
  },
		vehicle={
      min_hover_height          = 0.23,
      max_hover_height          = 0.8,
      use_water_rooster         = false,
        smooth_tilting            = false,
        smooth_tilting_speed      = 10,
        smooth_tilting_max_offset = -20,
      pos                       = {x=0,y=0,z=0},
      mesh                      = "ninjamono.obj",
      shader                    = "VertexColorUnlitTinted",
      layer                     = 14,
      texture                   = "ninjamonowhite.png",
      reflect                   = false,
      renderqueue               = 2000,
      shadercolors              = {
        _Color                   = {
          colorsource             = "highwayflat",
          scaletype               = "intensity",
          minscaler               = 0.6,
          maxscaler               = 1.5,
        },
        _RimColor                = {255,255,255},
      },
      scale                     = {x=1,y=1,z=1},
    	thrusters                 = {
    		shader                   = "VertexColorUnlitTinted",
    		layer                    = 14,
    		renderqueue              = 2999,
    		colorscaler              = .75,
    		extrusions               = 22,
    		stretch                  = -0.1191,
    		updateseconds            = 0.025,
    		crossSectionShape        = {{-.35,-.35,0},{-.5,0,0},{-.35,.35,0},{0,.5,0},{.35,.35,0},{.5,0,0},{.35,-.35,0}},
    		perShapeNodeColorScalers = {.5,1,1,1,1,1,.5},
    		instances                = {
    			{pos={0,.46,-1.28},rot={0,0,0},scale={.4,.4,.7}},
    			{pos={.175,0.21,-1.297},rot={0,0,58.713},scale={.4,.4,.7}},
    			{pos={-.175,0.21,-1.297},rot={0,0,313.7366},scale={.4,.4,.7}},
    		}
		}
	}
}
end



--============================================================--Player Appearance--============================================================--

--==================================================================--SkyBox--=================================================================--

--SetSkybox{skysphere = "kawaii/1.jpg"}

if lewd then randomSkyMax = (kawaiiCount + lewdCount) else randomSkyMax = kawaiiCount end
randomSky = math.random(1,randomSkyMax)

if randomSky <= kawaiiCount then
    randomSky = "kawaii/" .. randomSky
else
    randomSky = "lewd/" .. (randomSky - kawaiiCount)
end

SetSkybox {
    skysphere = randomSky .. ".jpg",
}



--==================================================================--SkyBox--=================================================================--

--===================================================================--Rails--=================================================================--
for i=1,10 do
if jumping then
	CreateRail{--left rail
	positionOffset={
		x=-trackWidth - .2,
		y=0},
	crossSectionShape={
		{x=-.65,y=0.5},
		{x=.3,y=0.5},
		{x=.3,y=-3},
		{x=-.65,y=-3}},
	perShapeNodeColorScalers={
		.5,
		1,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	fullfuture = true,
	layer = 13,
	shader="VertexColorUnlitTintedAdd"
	}
	CreateRail{--right rail
	positionOffset={
		x=trackWidth + .2,
		y=0},
	crossSectionShape={
		{x=-.3,y=0.5},
		{x=.65,y=0.5},
		{x=.65,y=-3},
		{x=-.3,y=-3}},
	perShapeNodeColorScalers={
		1,
		.5,
		0,
		0},
	colorMode="highway",
	color = {r=255,g=255,b=255},
	flatten=false,
	layer = 13,
	fullfuture = true,
	shader="VertexColorUnlitTintedAdd"
	}
else

	CreateRail{--road surface
		positionOffset={
			x=0,y=0,},
		crossSectionShape={
			{x=-trackWidth,y=0},
			{x=trackWidth,y=0},
			},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {51,51,51,125},
		flatten=false,
		fullfuture = ifhifi(true, false),
		shader="VertexColorUnlitTintedAlpha",
		renderqueue=3001,
	}


	--right edge
	CreateRail{
		positionOffset={
			x=0 ,
			y=-0.48},
		crossSectionShape={
			{x=fif(casual, 7.80, 4.80),y=0.5},
			{x=fif(casual, 8, 5),y=0.5}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="aurora",
		color = {r=0,g=0,b=0},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedQuadruple",
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=5}},
	}

	CreateRail{
		positionOffset={
			x=0 ,
			y=-0.46},
		crossSectionShape={
			{x=fif(casual, 7.96, 4.96),y=0.5},
			{x=fif(casual, 8, 5),y=0.5}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=0},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedQuadruple",
	}
	CreateRail{
		positionOffset={
			x=0 ,
			y=-0.46},
		crossSectionShape={
			{x=fif(casual, 7.76, 4.76),y=0.5},
			{x=fif(casual, 7.80, 4.80),y=0.5}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=0},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedQuadruple",
	}


	--left edge
	CreateRail{
		positionOffset={
			x=0 ,
			y=-0.48},
		crossSectionShape={
			{x=fif(casual, -7.80, -4.80),y=0.5},
			{x=fif(casual, -8, -5),y=0.5}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="aurora",
		color = {r=0,g=0,b=0},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedQuadruple",
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=5}},
	}

	CreateRail{
		positionOffset={
			x=0 ,
			y=-0.46},
		crossSectionShape={
			{x=fif(casual, -7.96, -4.96),y=0.5},
			{x=fif(casual, -8, -5),y=0.5}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=0},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTintedQuadruple",
		shadercolors={
			_Color = {colorsource="highway", scaletype="intensity", minscaler=3, maxscaler=5}},
	}
	CreateRail{
		positionOffset={
			x=0 ,
			y=-0.46},
		crossSectionShape={
			{x=fif(casual, -7.76, -4.76),y=0.5},
			{x=fif(casual, -7.80, -4.80),y=0.5}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="static",
		color = {r=0,g=0,b=0},
		flatten=false,
		texture="White.png",
		shader="VertexColorUnlitTinted",
	}
end

--Lane Dividers
for i=1,#laneDividers do
		CreateRail{ -- lane line
			positionOffset={
				x=laneDividers[i],
				y=0.02},
			crossSectionShape={
				{x=-.02,y=0},
				{x=.02,y=0}},
			perShapeNodeColorScalers={
				1,
				1},
			colorMode="aurora",
			color = {r=230,g=230,b=230},
			flatten=false,
			--nodeskip = 2,
			wrapnodeshape = false,
			shader="VertexColorUnlitTintedQuadruple",
		}
	end
end

if casual then
	for i=1,#shoulderLines do
	CreateRail{ -- shoulder line for casual modes
		positionOffset={
			x=shoulderLines[i],
			y=0.02},
		crossSectionShape={
			{x=-.03,y=0},
			{x=.03,y=0}},
		perShapeNodeColorScalers={
			1,
			1},
		colorMode="highway",
		color = {r=200,g=200,b=200},
		flatten=false,
		wrapnodeshape = false,
		shader="VertexColorUnlitTintedQuadruple",
	}
    end
end

--===================================================================--Rails--=================================================================--


--===================================================================--Misc.--=================================================================--


SetRings{ --setup the tracks tunnel rings. the airtexture is the tunnel used when you're up in a jump
	texture=fif(rings,(ByQuality4("Classic_OnBlack_256.png", "Classic_OnBlack_512.png", "Classic_OnBlack_1024.png", "Classic_OnBlack_1024.png")),"black.png"),
	--texture = ByQuality4("Classic_OnBlack_256.png", "Classic_OnBlack_512.png", "Classic_OnBlack_1024.png", "Classic_OnBlack_1024.png"),
	shader=fif(rings, "VertexColorUnlitTintedAddSmooth", "VertexColorUnlitTintedAlpha"),
	layer=13, -- on layer13, these objects won't be part of the glow effect
	size=fif(rings, trackWidth*5, 0),
	offset = fif(jumping, {0,0,0}, {0,1,0}),
	percentringed=fif(rings, fif(jumping, .2, .1), 0),
	airtexture="alpha.png",
	airshader="VertexColorUnlitTintedAddSmoothNoDepth",
	airsize=20,
}

if jumping then
	wakeHeight = 2
else
	wakeHeight = 0


	SetWake{ --setup the spray coming from the two pulling "boats"
	height = wakeHeight,
	fallrate = .999,
	shader = "VertexColorUnlitTintedAddSmooth",
	layer = 13,
	bottomcolor = "aurora",
	topcolor = {r=0,g=0,b=0}
}

CreateObject{
	name="EndCookie",
	tracknode="end",
	gameobject={
		transform={pos={0,0,126},scale={scaletype="intensity",min={55,99,900},max={66,120,900}}},
		mesh="danishCookie_boxes.obj",
		shader="RimLightHatched",
		shadercolors={
			_Color={142,142,142,10}
		}
	}
}
end

--===================================================================--Misc.--=================================================================--


--=============================================================================================================================================--
--==================================================================--END--=================================================================--
--=============================================================================================================================================--
